;MODIFIES PLAYER HEALTH
;object:
;DWORD [obj] = VTable Pointer
;DWORD [obj+4] = n/a
;DWORD [obj+8] = hit points to substract from player health
;                   (0 for full health/heal fully)
;DWORD [obj+12] = run once value
;       bit 0 = should be run only once?
;       bit 1 = has been run once? (only valid if bit 0 set)
;DWORD [obj+16] = saved run once value (for re-init)

struct CAT104
       lpVTable 		dd	?
       refCount 		dd	?
       HitPointsToSub		dd	?
       Flags			dd	?
       InitialFlags		dd	?
ends

align 16
;==========================================================
AT104MAIN:
;==========================================================
cmp BYTE [ecx+12],3
    jz NoPlayerHealthChange_104
	or BYTE [ecx+12],2

	mov eax,[PLAYER_OBJ_INVUL_ADDR] ;also for INVUL cheat
	mov edx,[eax]			;edx='player' object

cmp DWORD [ecx+8],0
    jz Full_Heal_104

	fld DWORD [edx+50h]		;current player health
	fsub DWORD [ecx+8]		;substract hit points
	fstp DWORD [edx+50h]		;store again

NoPlayerHealthChange_104:
ret

Full_Heal_104:
	mov eax,[edx+54h]		;max player health
	mov [edx+50h],eax
ret

align 16
;==========================================================
AT104_REINIT:
;==========================================================
mov eax,[ecx+16]
mov [ecx+12],eax
mov eax,[esp+4] 	;standard
ret 4

align 16
;====================================================================
_AT104Init:
;====================================================================
ALLOCAT 20
lea eax,[AT104]
mov [edi],eax
    xor eax,eax
mov [edi+4],eax
mov [edi+8],eax
mov [edi+12],eax

GETVALUE Frame,0
SETVALUE value_float,3

GETVALUE LoopCount,1
SETVALUE value_bool,4

mov eax,[edi+12]
mov [edi+16],eax

	jmp ExitINAT
