;============================================================
;code run before every frame is drawn for LOC-MAP cheats
;============================================================
;note: main surface object retrieved from
;DWORD [DWORD [BaseDDSurfaceADDR]]
;is only valid in this portion of code and similar sections

LOC_MAP_NEW_TEST_CODE:		;called before every frame flip

	push ebp
	push esi
	push edi
	push edx
	push ecx
	push ebx
	push eax

	mov [IsInGame_BOOL],TRUE

;check counter for time spent in menu
	cmp [NotInGame_BOOL],0
	    jz NO_LOC_MAP_NEW_TEST_CODE_REENTER
	    mov [NotInGame_BOOL],0
	    invoke GetTickCountTRUE
	    mov [NotInGameEnd_TICK],eax
	    sub eax,[NotInGameStart_TICK]
	    add [NotInGame_TOTALMENUTIME],eax
	NO_LOC_MAP_NEW_TEST_CODE_REENTER:

;Quick-Save call
	cmp [IsInConsole_BOOL],TRUE
	    jz NoATX_QUICKSAVE_RT_PreCall
	    BBMCALL ATX_QUICKSAVE_RT,[QUICKSAVE_enabled]
	NoATX_QUICKSAVE_RT_PreCall:

;external functions
	BBMCALL TestForFlyModeKeys,[FLY_MODE_BOOL]
	BBMCALL FLY_Exit_Teleport,[FLY_Exit_Queued_BOOL]
	;BBMCALL DirectDrawMain,[Effects_BOOL]

	BBMCALL DisplayHUD_RT,[UseHUD]
	BBMCALL CalcPlayerPathTracesRT,[PT_enabled]
	BBMCALL SHOWMAP_CODE,[USE_MAP]
	call SetNewTimeStamp

	BBMCALL RecordVideoCaptureRT_NEW,[VideoEnabledBool]
	BBMCALL DisplayPlayerHealth,[ShowPlayerHealth_BOOL]
	BBMCALL DisplayDinoInfoMain,[DisplayDinoInfo_BOOL]
	BBMCALL DisplayDrawDistance,[DrawDistDisplayTime]
	BBMCALL DisplayNewKeysState,[ToggleKeysShowStateTime]
	BBMCALL DisplayPlayerFaceFloats,[ShowFaceFloats_BOOL]
	BBMCALL DisplayFPS,[FPS_toggle]
	;BBMCALL DisplayTest_Main,[Test_Main_BOOL]
	BBMCALL ATXDRV_MAIN_RT_PROC,[ATXDRV_ENABLED]
	;BBMCALL DisplayCONVTOFACINGPop,[UseTestCTFRATE]
	BBMCALL DISPLAYBUFFERSIZES,[UseBUFSIZEInfo]
	BBMCALL DISPLAYOBJCHEAT,[UseObjCheat]
	BBMCALL MXTInGameIntervalHandler,[MXTStateEnabled]
	BBMCALL DisplayGameSpeed,[DisplayGSPD_BOOL]
	BBMCALL DisplayLINSTData,[LINST_enabled]
	BBMCALL FIXOBJECTSPEED_RT,[FIXS_mainbuffer]
	BBMCALL DoTHIRDPAIMCheatRTMain,[THIRDPAIM_enabled]
	BBMCALL DisplayErrorCount,[LAST_ERROR_TIME]
	BBMCALL DisplayTempMessage,[TempMessageTime]

	pop eax
	pop ebx
	pop ecx
	pop edx
	pop edi
	pop esi
	pop ebp

cmp [USE_LOC],1
jz USE_LOC_IN_EXE_CODE
	add esp,4		;get rid of return address from call
	jmp [NO_LOC_JUMP_ADDR]	;jump if LOC disabled
USE_LOC_IN_EXE_CODE:

ret				;if LOC cheat enable, just continue




