;For ALF disassembly files created with W32Dasm v8.93 only (AND NOT MODIFIED).
;WILL CRASH IF ALF FILE HAS BEEN MOFIFIED OR IS INVALID!
;WILL ONLY REPORT PROCS WITH MORE THAN ONE CALL REFERENCES!
;INCLUDES JUMP REFERENCES, BUT ONLY IF PROC HAS TWO OR MORE CALL REFERENCES!
;NOT ALWAYS RELIABLE OR ACCURATE!
;HAS NO GUI!
;GIVES NO PROGRESS REPORT!
;MAY TAKE VERY, VERY LONG BEFORE FINAL MESSAGE BOX APPEARS FOR LARGE DISASSEMBLIES!
;NO ADEQUATE ERROR MESSAGES!
;MAY REQUIRE A GOOD AMOUNT OF MEMORY!
;NOT A GOOD PROGRAM!
;DO NOT USE!

WDASMPROCSTATSVERSION	      equ     '1.0'

format PE GUI 4.0
entry START
stack 20000h

include '%fasminc%\WIN32A.INC'	;must have FASM environment variable set properly for this

MACRO CLOSEHANDLE _handle {
local nohandle
      cmp _handle,0
	  jz nohandle
      invoke CloseHandle,_handle
      nohandle:
      }

MACRO LOCALRELEASE buffer1 {
      local NoRelease
	    cmp buffer1,0
	    jz NoRelease
	       invoke LocalFree,buffer1
	    NoRelease:
	}

;=================================================================
section '.code' code readable executable
;=================================================================
START:
push ebp
push ebx
push edi
push esi

       mov [OFN_info.lStructSize],sizeof.OPENFILENAME
       mov [OFN_info.lpstrFilter],filter_strings
       mov [OFN_info.lpstrFile],source_alf_file
       mov [OFN_info.nMaxFile],512
       mov [OFN_info.lpstrDefExt],default_extension
       mov [OFN_info.lpstrTitle],open_file_caption
       mov [OFN_info.Flags],OFN_FILEMUSTEXIST+OFN_LONGNAMES+OFN_PATHMUSTEXIST+OFN_EXPLORER
invoke GetOpenFileName,OFN_info
       test eax,eax
	    jz MAINEXIT

       mov esi,source_alf_file
       mov edi,dest_txt_file
       call TransferString
       mov DWORD [edi-4],'_ST.'
       mov DWORD [edi],00747874h	;'txt',0

invoke CreateFile,source_alf_file,GENERIC_READ,FILE_SHARE_READ,0,OPEN_EXISTING,\
			FILE_ATTRIBUTE_NORMAL,0,0
       test eax,eax
       mov [source_alf_handle],eax
	   jz MAINEXIT
       cmp eax,-1
	   jz MAINEXIT

invoke GetFileSize,[source_alf_handle]
       cmp eax,-1
       mov [filesize],eax
	   jz MAINEXIT
       cmp eax,100
	   jb MAINEXIT

invoke CreateFileMapping,[source_alf_handle],0,PAGE_READONLY,0,0,0
       test eax,eax
       mov [source_alf_fhandle],eax
	   jz MAINEXIT

invoke MapViewOfFile,[source_alf_fhandle],FILE_MAP_READ,0,0,0
       test eax,eax
       mov [source_alf_maphandle],eax
	   jz MAINEXIT

;output file (create early)
invoke CreateFile,dest_txt_file,GENERIC_WRITE,0,0,CREATE_ALWAYS,\
			FILE_ATTRIBUTE_NORMAL,0,0
       test eax,eax
       mov [dest_txt_handle],eax
	   jz MAINEXIT
       cmp eax,-1
	   jz MAINEXIT

invoke wsprintf,temp_buf,TXT_INTRO,source_alf_file
       add esp,12

invoke WriteFile,[dest_txt_handle],temp_buf,eax,temp_var,0

invoke LocalAlloc,LPTR,40h	     ;12 for string, 4 for number of refs
       test eax,eax
       mov [recordbuffer],eax
	   jz MAINEXIT
       mov [recordbuffersize],0

;ebx = main scan index
       mov ebx,[source_alf_maphandle]
       mov eax,[filesize]
       add eax,ebx
       sub eax,100			 ;facilitates limit checking (but assumes file is valid)
       mov [source_alf_mapend],eax

;============================================================
MAINSEARCHLOOP:
       cmp DWORD [ebx],'* Re'
	   jnz NotReferencedStrStart
	   add ebx,18
	   cmp DWORD [ebx],'CALL'
	       jnz NotReferencedStrStart
	   add ebx,22			;next line?
	   cmp DWORD [ebx-4],3A7C0A0Dh	     ;return + "|:"
	       jnz NotReferencedStrStart
	   mov eax,[recordbuffersize]
	   mov edi,eax
	   add eax,12+4
	   push LMEM_MOVEABLE
	   mov [recordbuffersize],eax
	   push eax
	   push [recordbuffer]
	   call [LocalReAlloc]

	   add edi,eax
	   test eax,eax
	   mov [recordbuffer],eax
	       jz MAINEXIT

	   mov DWORD [edi+12],1 	;(at least one call)
       ;count bars and commas loop (number of proc calls) (count pointed to by edi+12)
	   xor eax,eax
	   MAINREFCOUNTLOOP:
	   cmp BYTE [ebx],','
	   sete al
	   add [edi+12],eax
	   cmp WORD [ebx],'|:'
	   sete al
	   add [edi+12],eax
	   inc ebx
	   cmp DWORD [ebx],03A0A0D7Ch	     ;"|" + return + ":"
	       jnz MAINREFCOUNTLOOP

	   add ebx,4
	   mov eax,[ebx]
	   mov edx,[ebx+4]
	   mov [edi],eax
	   mov [edi+4],edx		;save proc address string
	   mov DWORD [edi+8],0
	   add ebx,4
       NotReferencedStrStart:

       inc ebx
       cmp ebx,[source_alf_mapend]
	   jb MAINSEARCHLOOP

;============================================================
;SORT FUNCTIONS BY AMOUNT OF REFERENCES (NOT OPTIMIZED!!!!!!!!!!!!!!!!!!!)

       mov esi,[recordbuffersize]
       mov eax,esi
       cmp esi,32
	   jb NoMainSortLoop
       shr esi,4		       ;loop count
       add eax,[recordbuffer]
       sub eax,16
       mov [recordbufferend],eax
	   jb NoMainSortLoop

MainSortLoop:
       mov edi,[recordbuffer]

       SubSortLoop:
	  mov eax,[edi+12]
	  mov edx,[edi+16+12]
	  cmp eax,edx
	      jnb SubSortLoopNoXchg
	      mov [edi+12],edx
	      mov [edi+16+12],eax
	      mov eax,[edi+16+0]
	      mov edx,[edi+0]
	      mov [edi+0],eax
	      mov [edi+16+0],edx
	      mov eax,[edi+16+4]
	      mov edx,[edi+4]
	      mov [edi+4],eax
	      mov [edi+16+4],edx	    ;note: all [edi+12] / +(16+8) values are NULL
	  SubSortLoopNoXchg:
	  add edi,16
	  cmp edi,[recordbufferend]
	      jb SubSortLoop

       dec esi
       jnz MainSortLoop

NoMainSortLoop:
;============================================================

       mov edi,[recordbuffer]
       mov eax,[recordbuffersize]
       cmp eax,16
	   jb NoMainWriteDestFileLoop
       add eax,edi
       mov esi,1
       mov [recordbufferend],eax

MainWriteDestFileLoop:
invoke wsprintf,temp_buf,NUMPROCCALLS_STR,esi,edi,[edi+12]
       add esp,20
invoke WriteFile,[dest_txt_handle],temp_buf,eax,temp_var,0
       add edi,16
       inc esi
       cmp edi,[recordbufferend]
	   jb MainWriteDestFileLoop
NoMainWriteDestFileLoop:

       mov eax,[recordbuffersize]
       shr eax,4
invoke wsprintf,temp_buf,NUMPROCSTOTAL_STR,eax
       add esp,12
invoke WriteFile,[dest_txt_handle],temp_buf,eax,temp_var,0


invoke MessageBox,0,error_success_1,msgbox_caption,0
jmp OVERMAINEXIT

MAINEXIT:
invoke MessageBox,0,error_notscanned_1,msgbox_caption,0
OVERMAINEXIT:

       cmp [source_alf_maphandle],0
	   jz Nosource_alf_maphandle_close
	   invoke UnmapViewOfFile,[source_alf_maphandle]
       Nosource_alf_maphandle_close:

       CLOSEHANDLE [source_alf_fhandle]
       CLOSEHANDLE [source_alf_handle]
       CLOSEHANDLE [dest_txt_handle]
       LOCALRELEASE [recordbuffer]

       pop esi
       pop edi
       pop ebx
       mov esp,ebp
       pop ebp
invoke ExitProcess,0

;============================================================
TransferString: 	;esi=source, edi=dest., destroyed: esi,edi, al
;============================================================
TransferStringLoop: ;edi points to dest.'s null-terminator (BYTE [edi] = 0)
     mov al,[esi]
     mov [edi],al	      ;transfer/append string
     test al,al
	  jz End_TransferStringLoop
     inc esi
     inc edi
     jmp TransferStringLoop
End_TransferStringLoop:
ret

;=================================================================
section '.data' data readable writeable
;=================================================================

msgbox_caption	     db      "WDASMPROCSTATS",0
OFN_info	     OPENFILENAME

filter_strings	     db      "ALF WDASM Disassembly Files",0,"*.alf",0
		     db      "All files",0,"*.*",0,0
default_extension    db      "alf",0
open_file_caption    db      "WDASMPROCSTATS - Select WDASM disassembly",0

TXT_INTRO	     db      "WDASM procedure calls stats data file",0Dh,0Ah
		     db      "ALF disassembly filename: %s",0Dh,0Ah,0Dh,0Ah
		     db      "Count",09h,"ProcAddress",09h,"Number of direct calls",0Dh,0Ah
		     db      0
NUMPROCCALLS_STR     db      "%u",09h,"%s",09h,"%u",0Dh,0Ah,0
NUMPROCSTOTAL_STR    db      0Dh,0Ah,"Total number of multiple-call reference procedures: %u",0Dh,0Ah,0

source_alf_file      db      512 dup 0
source_alf_handle    dd      0
source_alf_fhandle   dd      0
source_alf_maphandle dd      0
source_alf_mapend    dd      0
filesize	     dd      0

temp_buf	     db      2000 dup 0

temp_var	     dd      0
recordbuffer	     dd      0
recordbuffersize     dd      0
recordbufferend      dd      0
dest_txt_file	     db      512 dup 0
dest_txt_handle      dd      0

error_success_1      db      "File scanned.",0
error_notscanned_1   db      "No File scanned.",0

;=================================================================
section '.idata' import data readable writeable
;=================================================================
  library kernel,'KERNEL32.DLL',\
	  user,'USER32.DLL',\
	  comdlg,'COMDLG32.DLL'

  import kernel,\
	 CloseHandle,"CloseHandle",\
	 CreateFile,"CreateFileA",\
	 CreateFileMapping,"CreateFileMappingA",\
	 ExitProcess,"ExitProcess",\
	 GetFileSize,"GetFileSize",\
	 GetLastError,"GetLastError",\
	 LocalAlloc,"LocalAlloc",\
	 LocalFree,"LocalFree",\
	 LocalReAlloc,"LocalReAlloc",\
	 MapViewOfFile,"MapViewOfFile",\
	 ReadFile,"ReadFile",\
	 SetFilePointer,'SetFilePointer',\
	 UnmapViewOfFile,"UnmapViewOfFile",\
	 WriteFile,'WriteFile'

  import user,\
	 MessageBox,'MessageBoxA',\
	 wsprintf,"wsprintfA"

  import comdlg,\
	 GetOpenFileName,'GetOpenFileNameA'

;=================================================================
section '.rsrc' resource data readable
;=================================================================

	directory RT_VERSION,versions

	resource versions,\
	   1,LANG_NEUTRAL,version

	versioninfo version,VOS__WINDOWS32,VFT_APP,VFT2_UNKNOWN,\
				LANG_ENGLISH+SUBLANG_DEFAULT,0,\
	  'FileDescription','Unofficial W32Dasm 8.93 proc stats',\
	  'LegalCopyright','Free, open source.',\
	  'FileVersion',WDASMPROCSTATSVERSION,\
	  'ProductVersion',WDASMPROCSTATSVERSION,\
	  'OriginalFilename','WDASMPROCSTATS.EXE'
